class Chart{
  int seriesNb;
  Series[] series= new Series[10];
  DimAxis dimAxis;
  ValAxis valAxis;
  ValAxis valAxis2;
  Boolean has2Axes = false;
  String title;
  String subtitle;
  String source;
  ChartStyle style;
  String[] label = new String[10];
  float[] labelX = new float[10];
  float[] labelY = new float[10];
  int labelNb;
  /*
  Simplified constructors 
  */
  Chart(float[][] myValues, String[] myLabels, String[] mySeriesNames, String myTitle, String myMode){
    title=myTitle;subtitle="";source="";
    init(myValues, myLabels, mySeriesNames, myMode);
  }
  
  Chart(float[][] myValues, String[] myLabels, String[] mySeriesNames, String myTitle, String mySubtitle, String myMode){
    title=myTitle;subtitle=mySubtitle;source="";
    init(myValues, myLabels, mySeriesNames, myMode);
  }
  
  Chart(float[][] myValues, String[] myLabels, String[] mySeriesNames, String myTitle, String mySubtitle, String mySource, String myMode){
    title=myTitle;subtitle=mySubtitle;source=mySource;
    init(myValues, myLabels, mySeriesNames, myMode);
  }
  
  void init(float[][] myValues, String[] myLabels, String[] mySeriesNames, String myMode){
    int labelFontSize = 7;
    String labelFont = "Verdana";
    if (myMode.equals("DEFAULT")){
      labelFontSize=8;
    }
    seriesNb = min(myValues.length,10);
    for(int i=0;i<seriesNb;i++){
      println("all going well "+i);
      series[i]= new Series(myValues[i],mySeriesNames[i],i);
    }

    style=new ChartStyle(myMode);
    dimAxis = new DimAxis(myLabels, labelFont, int(style.chartHeight/32));
    valAxis = new ValAxis(myValues, labelFont, int(style.chartHeight/32));
    style.updateSize(this);
  }
    
  /*
  Full constructor
  */
  Chart(String[] dataFile){
    boolean debug=false;
    String[] myLabels = new String[1000];  
    String[] mySeriesNames = new String[10];
    float[][] myValues = new float[10][1000];
    int dataIndex=0;
    int formatIndex=0;
    int textIndex=0;
    title="";subtitle="";source="";
    
    String[] seriesType = new String[10];
    String[] seriesFill = new String[10];
    String[] seriesBorder= new String[10];
             
    float valmax=0, valmin=0, valstep=0;
    float valmax2=0, valmin2=0, valstep2=0;
    boolean valmaxSet=false, valminSet=false, valstepSet=false;
    boolean valmax2Set=false, valmin2Set=false, valstep2Set=false;
    
    String valTitle="", valTitle2="";
    boolean valShowTitle=false, valShowTitle2=false;
    
    int chartWidth =410 , chartHeight=320;
    float barWidth = 0.75;
    int plotX1=0, plotY1=0, plotX2=0, plotY2=0;
    boolean plotX1Set=false, plotY1Set=false, plotX2Set=false, plotY2Set=false;
    String styleMode="";
    
    boolean showTitle=false;
    boolean showSubtitle=false;
    boolean showLegend=false;
    boolean showSource=false;
    color chartAreaColor = #F9F9F9;
    color plotAreaColor = #FFFFFF;
    color gridLineColor = #CCCCCC;
    color plotBorderColor= #CCCCCC;
    
    String titleFontName = "Gill Sans MT";
    float titleFontSize = 18;
    String subtitleFontName = "Gill Sans MT Italic";
    float subtitleFontSize = 14;
    String labelFontName = "Arial Narrow";
    float labelFontSize=12;
    
    boolean ticks = false;
    boolean between = true;
    boolean tilted = false;
    int interval=1;
    boolean reSize = true;
    boolean horizontal = true;
    
    String colorStyle = "DISCRETE";
    
    for (int i = 0; i < dataFile.length; i++){
      if ((trim(dataFile[i]).length() == 0)||(dataFile[i].startsWith("#"))) {
        continue; 
      }
      String[] components = split(dataFile[i], ":");
      if (components.length>2){
        for (int j=0; j<components.length-1;j++){
          if (components[j].charAt(components[j].length()-1)=='\\') {
            components[j]=components[j].substring(components[j].length()-1)+":"+components[j+1]; 
            for (int k=j+1; k<components.length-1;k++){
              components[k]=components[k+1];
            }
          }
        }
      }
      components[0]=trim(components[0].toLowerCase());
      
      if (components[0].equals("title"))          {title=components[1];if(title.length()>0){showTitle=true;}} 
      else if (components[0].equals("subtitle"))  {subtitle=components[1];if(subtitle.length()>0){showSubtitle=true;}}
      else if (components[0].equals("source"))    {source=components[1];if(source.length()>0){showSource=true;}}
      else if (components[0].equals("labels"))    {myLabels=split(components[1], TAB);}

      else if (components[0].equals("valmax"))    {valmax  =float(components[1]);valmaxSet=true;}
      else if (components[0].equals("valmin"))    {valmin  =float(components[1]);valminSet=true;}
      else if (components[0].equals("valstep"))   {valstep =float(components[1]);valstepSet=true;}
      else if (components[0].equals("valmax2"))   {valmax2 =float(components[1]);has2Axes=true;valmax2Set=true;}
      else if (components[0].equals("valmin2"))   {valmin2 =float(components[1]);has2Axes=true;valmin2Set=true;}
      else if (components[0].equals("valstep2"))  {valstep2=float(components[1]);has2Axes=true;valstep2Set=true;}

      else if (components[0].equals("valtitle"))  {valTitle=components[1];valShowTitle=true;}
      else if (components[0].equals("valtitle2")) {subtitle=components[1];valShowTitle2=true;}
      
      else if (components[0].equals("valaxis"))   {
        String[] valaxis=split(components[1],TAB);
        if (valaxis.length>2)
        valmax=float(valaxis[0]);valmaxSet=true;
        valmin=float(valaxis[1]);valminSet=true;
        valstep=float(valaxis[2]);valstepSet=true;
        if (valaxis.length>3)
        valTitle=valaxis[3];
        valShowTitle=true;
      }
      else if (components[0].equals("valaxis2"))   {
        has2Axes=true;
        String[] valaxis=split(components[1],TAB);
        if (valaxis.length>2)
        valmax2=float(valaxis[0]);valmax2Set=true;
        valmin2=float(valaxis[1]);valmin2Set=true;
        valstep2=float(valaxis[2]);valstep2Set=true;
        if (valaxis.length>3)
        valTitle2=valaxis[3];
        valShowTitle2=true;
      }
      else if (components[0].equals("titlefont"))       {titleFontName =components[1];}
      else if (components[0].equals("titlefontsize"))   {titleFontSize =int(components[1]);}
      else if (components[0].equals("subtitlefont"))    {subtitleFontName =components[1];}
      else if (components[0].equals("subtitlefontsize")){subtitleFontSize =int(components[1]);}
      else if (components[0].equals("labelfont"))       {labelFontName =components[1];}
      else if (components[0].equals("labelfontsize"))   {labelFontSize =int(components[1]);}
      
      else if (components[0].equals("between"))   {between = boolean(components[1]);}
      else if (components[0].equals("ticks"))     {ticks = boolean(components[1]);}
      else if (components[0].equals("tilted"))    {tilted = boolean(components[1]);}
      else if (components[0].equals("interval"))  {interval = int(components[1]);}
      
      else if (components[0].equals("width"))     {chartWidth =int(components[1]);}
      else if (components[0].equals("height"))    {chartHeight=int(components[1]);}
      else if (components[0].equals("barwidth"))  {barWidth   =float(components[1]);}
      
      else if (components[0].equals("chartarea")) {chartAreaColor=unhex(components[1]);}
      else if (components[0].equals("plotarea"))  {plotAreaColor=unhex(components[1]);}
      else if (components[0].equals("gridline"))  {gridLineColor=unhex(components[1]);}      
      else if (components[0].equals("plotborder")){plotBorderColor=unhex(components[1]);}
      
      else if (components[0].equals("x1"))     {plotX1 =int(components[1]);plotX1Set=true;}
      else if (components[0].equals("x2"))     {plotX2 =int(components[1]);plotX2Set=true;}
      else if (components[0].equals("y1"))     {plotY1 =int(components[1]);plotY1Set=true;}
      else if (components[0].equals("y2"))     {plotY2 =int(components[1]);plotY2Set=true;}
      
      else if (components[0].equals("mode"))     {styleMode =components[1];}
      else if (components[0].equals("colormode")){colorStyle=components[1];}
      else if (components[0].equals("resize"))   {reSize=boolean(components[1]);}
      else if (components[0].equals("horizontal")){horizontal=boolean(components[1]);}
      else if (components[0].equals("showtitle")){showTitle=boolean(components[1]);}
      else if (components[0].equals("showsubtitle")){showSubtitle=boolean(components[1]);}
      else if (components[0].equals("showlegend")){showLegend=boolean(components[1]);}
      else if (components[0].equals("showsource")){showSource=boolean(components[1]);}
      else if (components[0].equals("text")){
        String[] myText = split(components[1],TAB);
        label[textIndex]=myText[0];
        labelX[textIndex]=float(myText[1]);
        labelY[textIndex]=float(myText[2]);
        textIndex++;
      }
      else if (components[0].equals("format")){
        String[] myFormat = split(components[1],TAB);
        seriesType[formatIndex]=myFormat[0];
        if (seriesType[formatIndex].equals("LINE")||seriesType[formatIndex].equals("AREA")||seriesType[formatIndex].equals("SAREA")){
          between=false;
          ticks=true;
        }
        if (myFormat.length>1) {
          seriesFill[formatIndex]=(myFormat[1]);
          if (myFormat.length>2) {
            seriesBorder[formatIndex]=(myFormat[2]);
          } else {
            colorMode(HSB);
            seriesBorder[formatIndex]=hex(color(hue(unhex(seriesFill[formatIndex])), saturation(unhex(seriesFill[formatIndex])), .5*brightness(unhex(seriesFill[formatIndex]))));
            colorMode(RGB);
          }            
        } else {seriesFill[formatIndex]="";seriesBorder[formatIndex]="";}
        formatIndex++;
      }
      else if (components[0].equals("data"))      {
        String[] mySeries=split(components[1],TAB);
        for (int j=0;j<mySeries.length;j++){
          myValues[dataIndex][j]=float(mySeries[j]);
        }
        dataIndex++;
      }
      else if (components[0].equals("series"))    {
        mySeriesNames=split(components[1], TAB);
        for (int j=0;j<mySeriesNames.length;j++){
          if (mySeriesNames[j].length()>0){showLegend=true;}
        }
      }
      
    } 
    
    if (styleMode.length()>0) {
      style=new ChartStyle(styleMode);
      if(debug) {println("Using pre-defined style: "+styleMode);}
      if (plotX1Set){style.plotX1=plotX1;}
      if (plotX2Set){style.plotX2=plotX2;}
      if (plotY1Set){style.plotY1=plotY1;}
      if (plotY2Set){style.plotY2=plotY2;}
      style.showTitle=showTitle;
      style.showSubtitle=showSubtitle;
      style.showLegend=showLegend;
      style.showSource=showSource;
    } else {
      if (!plotX1Set){plotX1=5;}
      if (!plotX2Set){plotX2=chartWidth-5;}
      if (!plotY1Set){plotY1=5;}
      if (!plotY2Set){plotY2=chartHeight-5;}
      style=new ChartStyle(chartWidth, chartHeight, titleFontName, titleFontSize, subtitleFontName, subtitleFontSize, showTitle, showSubtitle, showLegend, showSource, horizontal, barWidth, plotAreaColor, chartAreaColor, gridLineColor, plotBorderColor, plotX1, plotX2, plotY1, plotY2);
      if(debug) {println("Constructing style. "+chartWidth+" "+chartHeight+" "+titleFontName+" "+titleFontSize+" "+subtitleFontName+" "+subtitleFontSize+" "+showTitle+" "+showSubtitle+" "+showLegend+" "+showSource+" "+horizontal+" "+barWidth+" "+plotAreaColor+" "+chartAreaColor+" "+gridLineColor+" "+plotBorderColor+" "+plotX1+" "+plotX2+" "+plotY1+" "+plotY2);}
    }
    for(int i=0;i<dataIndex;i++){
      if(debug) {println("Building series "+i);}
      series[i]= new Series(myValues[i],mySeriesNames[i],i);
    }
    seriesNb=dataIndex;
    labelNb = textIndex;
    dimAxis = new DimAxis(myLabels, labelFontName, labelFontSize);
    if (tilted) {dimAxis.style.angle = PI/6;}
    dimAxis.style.tick = ticks;
    dimAxis.style.between = between;
    dimAxis.style.interval = interval;
    if(debug) {println("Nb Values:"+dimAxis.nbValues);}
    valAxis = new ValAxis(myValues, labelFontName, labelFontSize);
    if (valShowTitle){valAxis.title=valTitle;valAxis.hasTitle=true;}
    if (valmaxSet){valAxis.maxVal=valmax;}
    if (valminSet){valAxis.minVal=valmin;}
    if (valstepSet){valAxis.step=valstep;}
    if (has2Axes){
      valAxis2= new ValAxis(myValues, labelFontName, labelFontSize);
      if (valShowTitle2){valAxis2.title=valTitle2;valAxis2.hasTitle=true;}
      if (valmax2Set){valAxis2.maxVal=valmax2;}
      if (valmin2Set){valAxis2.minVal=valmin2;}
      if (valstep2Set){valAxis2.step=valstep2;}
    }
    
    if (colorStyle.equals("GRADIENT")) {reColor("GRADIENT");} else {reColor("DISCRETE");}
    
    for (int i=0;i<formatIndex;i++){
      series[i].style.type=seriesType[i];
      if(seriesFill[i].length()>0){
        if (seriesFill[i].length()==6){seriesFill[i]="FF"+seriesFill[i];}
        if (seriesBorder[i].length()==6){seriesBorder[i]="FF"+seriesBorder[i];}
        series[i].style.seriesFill=unhex(seriesFill[i]);
        series[i].style.seriesBorder=unhex(seriesBorder[i]);
      }
      if(debug){println("Style of series "+i+": "+series[i].style.type+" "+series[i].style.seriesFill+" "+series[i].style.seriesBorder);}
  }
    
    if (reSize){style.updateSize(this);}
  }  
    
  
  void reColor(String mode){
    color[] stone = {#1f77b4, #ff7f0e, #2ca02c, #d62728, #9667bd, #8c564b, #e377c2, #7f7f7f, #bcbd22, #17becf};
    if (mode.equals("DISCRETE")) {
      colorMode(RGB);
      for(int i=0;i<seriesNb;i++){series[i].style.seriesFill=stone[i];}
    } else if (mode.equals("GRADIENT")){
      colorMode(HSB);
      float hue0=hue(series[0].style.seriesFill);
      float sat0=saturation(series[0].style.seriesFill);
      float bri0=brightness(series[0].style.seriesFill);
      for(int i=1;i<seriesNb;i++){series[i].style.seriesFill=color(hue0,map(i,0, seriesNb,sat0,(sat0<96?sat0:96)),map(i,0,seriesNb,bri0,(bri0>224?bri0:224)));}
    }
    colorMode(HSB);
    for(int i=0;i<seriesNb;i++){series[i].style.seriesBorder=color(hue(series[i].style.seriesFill), saturation(series[i].style.seriesFill), .5*brightness(series[i].style.seriesFill));}
    colorMode(RGB);
  }

  void display(){
    boolean debug = false;
    
    float plotX1=style.plotX1, plotX2=style.plotX2, plotY1=style.plotY1, plotY2=style.plotY2;
    int nbValues = dimAxis.nbValues;
    boolean horizontal = style.horizontal;
    
    
    // 0. Calculation of dimensions & finetuning
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------  
    

    
    rectMode(CORNERS);
    size(style.chartWidth, style.chartHeight);
    
    // 0.a useful measures for the rest of the procedure

    float slotWidth, barWidth;
    if (horizontal){
      slotWidth = ((plotX2-plotX1))/(nbValues-(dimAxis.style.between?0:1));
      barWidth = (slotWidth*style.barWidth)/seriesNb;
      if (debug) {println((plotX2-plotX1)+" "+nbValues+" "+slotWidth);}
    } 
    else {
      slotWidth = (plotY2-plotY1)/(nbValues-(dimAxis.style.between?0:1));
      barWidth = (slotWidth*style.barWidth)/seriesNb;
    }
    if (debug) {println("slotWidth: "+slotWidth);println("barWidth: "+barWidth);}
  
    
    
    //
    // 1. Before plotting values
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------
    
    
    /// 1.a plot area

    stroke(style.plotBorderColor);
    fill(style.plotAreaColor);
    rect(plotX1,plotY1,plotX2,plotY2);
    
    /// 1.b  gridlines

    if(horizontal){
      for(float i=valAxis.minVal;i<=valAxis.maxVal;i+=valAxis.step){
        float labelY = map(i,valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
        stroke(style.gridLineColor);
        line(plotX1,labelY,plotX2,labelY);        
      }
    }
    else {
      for(float i=valAxis.minVal;i<=valAxis.maxVal;i+=valAxis.step){
        float labelX = map(i,valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
        stroke(style.gridLineColor);
        line(labelX,plotY1,labelX,plotY2);        
      }
    }
    
    //   
    // 2. series    
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------
    
    for (int i=0;i<seriesNb;i++) {
      if (series[i].style.type.equals("BAR")) {
        for (int j=0;j<nbValues;j++){
          float rectX1, rectX2, rectY1, rectY2;
          stroke(series[i].style.seriesBorder);
          fill(series[i].style.seriesFill);
          if (horizontal){
            rectX1 = plotX1+(j+.5*(1-style.barWidth))*slotWidth+i*barWidth;
            rectX2 = rectX1+barWidth-1;
            rectY1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
            rectY2 = map(0,valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            rectX1 = map(0, valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            rectX2 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            rectY1 = plotY1+(j+.5*(1-style.barWidth))*slotWidth+i*barWidth;
            rectY2 = rectY1+barWidth-1;
          }
          if (debug)  {println("rectangle "+j+": "+rectX1+" "+rectX2+" "+rectY1+" "+rectY2);}
          rect(rectX1, rectY1, rectX2,  rectY2);
        }
      }
      if (series[i].style.type.equals("SBAR")) {
        for (int j=0;j<nbValues;j++){
          float rectX1, rectX2, rectY1, rectY2;
          float val=0;
          for (int k=0;k<i;k++){val+=series[k].values[j];}
          stroke(series[i].style.seriesBorder);
          fill(series[i].style.seriesFill);
          if (horizontal){
            rectX1 = plotX1+(j+.5*(1-style.barWidth))*slotWidth;
            rectX2 = rectX1+slotWidth*style.barWidth-1;
            rectY1 = map(series[i].values[j]+val, valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
            rectY2 = map(val,valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            rectX1 = map(val, valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            rectX2 = map(series[i].values[j]+val, valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            rectY1 = plotY1+(j+.5*(1-style.barWidth))*slotWidth;
            rectY2 = rectY1+slotWidth*style.barWidth-1;
          }
          if (debug)  {println("rectangle "+j+": "+rectX1+" "+rectX2+" "+rectY1+" "+rectY2);}
          rect(rectX1, rectY1, rectX2,  rectY2);
        }
      }
      if (series[i].style.type.equals("LINE")) {
        stroke(series[i].style.seriesFill);
        strokeWeight(2);
        smooth();
        noFill();
        beginShape();
        for (int j=0;j<nbValues;j++){
          float lineX1, lineY1;
          if (horizontal){
            lineX1 = plotX1+j*slotWidth + (dimAxis.style.between?barWidth/2:0);
            if (lineX1<=plotX1){lineX1++;}else if(lineX1>=plotX2){lineX1--;}
            lineY1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            lineX1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            lineY1 = plotY1+(dimAxis.style.between?barWidth/2:0);
            if(lineY1<=plotY1){lineY1++;}else if(lineY1>=plotY2){lineY1--;}
          }
          if (debug)  {println("point "+j+": "+lineX1+" "+lineY1);}
          vertex(lineX1, lineY1);
        }
        endShape();
        strokeWeight(1);
      }
      if (series[i].style.type.equals("DOTS")) {
              fill(series[i].style.seriesFill);
              stroke(series[i].style.seriesBorder);
              strokeWeight(2);
              smooth();
              
              beginShape();
              for (int j=0;j<nbValues;j++){
                float dotX1, dotY1;
                if (horizontal){
                  dotX1 = plotX1+j*slotWidth + (dimAxis.style.between?barWidth/2:0);
                  if(dotX1<=plotX1){dotX1++;}else if(dotX1>=plotX2){dotX1--;}
                  dotY1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
                } 
                else {
                  dotX1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
                  dotY1 = plotY1+(dimAxis.style.between?barWidth/2:0);
                  if(dotY1<=plotY1){dotY1++;}else if(dotY1>=plotY2){dotY1--;}
                }
                if (debug)  {println("point "+j+": "+dotX1+" "+dotY1);}
                ellipse(dotX1, dotY1, 5, 5);
              }
              strokeWeight(1);
      }
      if (series[i].style.type.equals("AREA")) {
        float lineX1=0, lineY1=0;
        stroke(series[i].style.seriesBorder);
        strokeWeight(1);
        smooth();
        fill(series[i].style.seriesFill);
        beginShape();
        vertex(plotX1, horizontal?plotY2:plotY1);
        for (int j=0;j<nbValues;j++){
          if (horizontal){
            lineX1 = plotX1+j*slotWidth + (dimAxis.style.between?barWidth/2:0);
            lineY1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            lineX1 = map(series[i].values[j], valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            lineY1 = plotY1+(dimAxis.style.between?barWidth/2:0);
          }
          if (debug)  {println("point "+j+": "+lineX1+" "+lineY1);}
          vertex(lineX1, lineY1);
        }
        if (horizontal) {
          vertex(lineX1,plotY2);
        } 
        else {
          vertex(plotX1,lineY1);
        }
        endShape(CLOSE);
        strokeWeight(1);
      }
      if (series[i].style.type.equals("SAREA")) {
        float lineX1=0, lineY1=0;
        stroke(series[i].style.seriesBorder);
        strokeWeight(1);
        smooth();
        fill(series[i].style.seriesFill);
        beginShape();
        vertex(plotX1, horizontal?plotY2:plotY1);
        for (int j=0;j<nbValues;j++){
          float val=0;
          for (int k=0;k<i;k++){
            val+=series[k].values[j];
          }  
          if (horizontal){
            lineX1 = plotX1+j*slotWidth + (dimAxis.style.between?barWidth/2:0);
            lineY1 = map(series[i].values[j]+val, valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            lineX1 = map(series[i].values[j]+val, valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            lineY1 = plotY1+(dimAxis.style.between?barWidth/2:0);
          }
          if (debug)  {println("point "+j+": "+lineX1+" "+lineY1);}
          vertex(lineX1, lineY1);
        }
        for (int j=nbValues-1;j>=0;j--){
          float val=0;
          for (int k=0;k<i;k++){
            val+=series[k].values[j];
          }  
          if (horizontal){
            lineX1 = plotX1+j*slotWidth + (dimAxis.style.between?barWidth/2:0);
            lineY1 = map(val, valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
          } 
          else {
            lineX1 = map(val, valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
            lineY1 = plotY1+(dimAxis.style.between?barWidth/2:0);
          }
          if (debug)  {println("point "+j+": "+lineX1+" "+lineY1);}
          vertex(lineX1, lineY1);
        }
        endShape(CLOSE);
        strokeWeight(1);
      }
    }
    
    
    
    // 3. After series
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------
    
    
    /// 3.a background
    
    fill(style.chartAreaColor);noStroke();
   
    rect(0,0,width,plotY1+1);                         // =======
    rect(0,plotY1,plotX1+1,plotY2);       // |
    rect(plotX2, plotY1,width,plotY2);    //       |
    rect(0,plotY2,width, height);                     // =======
    
      
    /// 3.b title
    
    fill(0);
    textFont(style.titleFont);
    textAlign(CENTER,TOP);
    float heightTitle=0;
    if (style.showTitle){
      text(title,style.chartWidth/2,style.chartHeight*.02);
      heightTitle += textAscent()+textDescent();
      heightTitle += (style.chartHeight*.02>7?style.chartHeight*.02:7);
    }
    if (style.showSubtitle){
      textFont(style.subtitleFont);
      text(subtitle, style.chartWidth/2, heightTitle);
      heightTitle += textAscent()+textDescent();
    }
    
    /// 3.c legend 
    
    if (style.showLegend){
      textFont(style.subtitleFont);
      float legendWidth=0;
      float currentX=0;
     
      if (style.showSubtitle==false){/*heightTitle+=10;*/}
      for (int i=0;i<seriesNb;i++){
        if (series[i].name.length()>0){
          legendWidth+=style.chartWidth*.1+textWidth(series[i].name);
        }
      }
      currentX=(style.chartWidth-legendWidth)/2;
      for (int i=0;i<seriesNb;i++){
        if (series[i].name.length()>0){
          textAlign(LEFT,TOP);
          stroke(series[i].style.seriesBorder);
          fill(series[i].style.seriesFill);
          rect(currentX, heightTitle, currentX+style.chartWidth*.05, heightTitle+textAscent()+textDescent());
          currentX+=style.chartWidth*.075;
          fill(0);
          text(series[i].name, currentX, heightTitle);
          currentX+=textWidth(series[i].name)+style.chartWidth*.025;
        }
      }
    }
    

    
    /// 3.d  values

    textFont(valAxis.font);
    if(horizontal){
      textAlign(RIGHT);
      for(float i=valAxis.minVal;i<=valAxis.maxVal;i+=valAxis.step){
        if(i==valAxis.minVal){
          textAlign(RIGHT,BOTTOM);
        }
        else if(i>valAxis.maxVal-valAxis.step){
          textAlign(RIGHT,TOP);
        }
        else{
          textAlign(RIGHT,CENTER);
        }       
        float labelY = map(i,valAxis.minVal, valAxis.maxVal, plotY2, plotY1);
        stroke(0);
        fill(0);
        line(plotX1, labelY, plotX1+2,labelY);
        text(nfs(i,0,0), plotX1-5, labelY);
      }
      if (valAxis.hasTitle) {textAlign(RIGHT,BOTTOM);pushMatrix();translate(plotX1-textWidth(nfs(valAxis.maxVal,0,0))-5, plotY1);rotate(3*PI/2);text(valAxis.title,0,0);popMatrix();} 
      if (has2Axes){
        stroke(0);
        line(plotX2, plotY1, plotX2, plotY2);
        for(float i=valAxis2.minVal;i<=valAxis2.maxVal;i+=valAxis2.step){
          if(i==valAxis2.minVal){
            textAlign(LEFT,BOTTOM);
          }
          else if(i>valAxis2.maxVal-valAxis2.step){
            textAlign(LEFT,TOP);
          }
          else{
            textAlign(LEFT,CENTER);
          }       
          float labelY = map(i,valAxis2.minVal, valAxis2.maxVal, plotY2, plotY1);
          stroke(0);
          fill(0);
          line(plotX2, labelY, plotX2-2,labelY);
          text(nfs(i,0,0), plotX2+5, labelY);
        }
        if (valAxis2.hasTitle) {textAlign(RIGHT,TOP);pushMatrix();translate(plotX2+textWidth(nfs(valAxis2.maxVal,0,0))+5, plotY1);rotate(3*PI/2);text(valAxis2.title,0,0);popMatrix();} 
      }
    }
    else {
      textAlign(CENTER,TOP);
      for(float i=valAxis.minVal;i<=valAxis.maxVal;i+=valAxis.step){
        float labelX = map(i,valAxis.minVal, valAxis.maxVal, plotX1, plotX2);
        stroke(0);
        fill(0);
        line(labelX, plotY2, labelX, plotY2-2);
        text(nfs(i,0,0), labelX, plotY2+5);
      }
    }

    /// 3.e dimensions
    
    //// 3.e.1 this is where we write the category labels

    textFont(dimAxis.font);
    if (horizontal){
      for(int i=0;i<nbValues;i+=dimAxis.style.interval){
        float labelX;
        textAlign(CENTER,TOP);
        if(dimAxis.style.between==false) {if(i==0){textAlign(LEFT,TOP);} else if(i==nbValues-dimAxis.style.interval){textAlign(RIGHT,TOP);}}
        if(dimAxis.style.angle!=0){textAlign(RIGHT,TOP);}
        labelX=plotX1+(i+(dimAxis.style.between?.5:0))*slotWidth;
        pushMatrix();
        translate(labelX-sin(dimAxis.style.angle)*(textAscent()+textDescent()), plotY2+(style.chartHeight/64));
        if (debug)  {println("translated from "+labelX+"/"+(plotY2+10.0));}
        rotate(-dimAxis.style.angle);
        text(dimAxis.labels[i],0,0);
        popMatrix();
        if(dimAxis.style.tick){stroke(0);line(labelX,plotY2,labelX,plotY2+2);} 
      }
    } 
    else {
      for(int i=0;i<nbValues;i+=dimAxis.style.interval){
        textAlign(LEFT,CENTER);
        if (i==0){textAlign(LEFT,TOP);}else if(i>=nbValues+dimAxis.style.interval){textAlign(LEFT,BOTTOM);}
        float labelY=plotY1+(i+.5)*slotWidth;
        text(dimAxis.labels[i],5,labelY);
        if(dimAxis.style.tick){stroke(0);line(plotX2-2,labelY,plotX2,labelY);}
      }
    }
    
    // 3.f source
    
    if (style.showSource&&(!source.equals(""))) {
      textFont(style.subtitleFont);
      textAlign(RIGHT,BOTTOM);
      text(source,width-5,height-5);
    }     
    
    // 3.g additional text
    textFont(dimAxis.font);textAlign(LEFT,BOTTOM);
    for (int i=0;i<labelNb;i++){text(label[i],labelX[i],labelY[i]);}

  
    // 4. axes
    // ---------------------------------------------------------------------------------------------------------------------------------------------------------
    
    stroke(0);
    line(plotX1,plotY1, plotX1, plotY2);
    line(plotX1,plotY2, plotX2, plotY2);
    if (horizontal){
      line(plotX1,map(0,valAxis.minVal, valAxis.maxVal, plotY2, plotY1), plotX2, map(0,valAxis.minVal, valAxis.maxVal, plotY2, plotY1));
    }
    else {
      line(map(0,valAxis.minVal, valAxis.maxVal, plotX1, plotX2), plotY1, map(0,valAxis.minVal, valAxis.maxVal, plotX1, plotX2), plotY2);
    }
  }
}

